diff --git a/package/kernel/ath10k-ct/Makefile b/package/kernel/ath10k-ct/Makefile
index b0ac5625c4..439dab3ddf 100644
--- a/package/kernel/ath10k-ct/Makefile
+++ b/package/kernel/ath10k-ct/Makefile
@@ -1,7 +1,7 @@
 include $(TOPDIR)/rules.mk
 
 PKG_NAME:=ath10k-ct
-PKG_RELEASE=1
+PKG_RELEASE=2
 
 PKG_LICENSE:=GPLv2
 PKG_LICENSE_FILES:=
@@ -12,10 +12,10 @@ PKG_SOURCE_DATE:=2020-08-25
 PKG_SOURCE_VERSION:=13319ff0b5dc3c86e8313f49fca583b829878736
 PKG_MIRROR_HASH:=4a082f9c5ee26fea1eb2f86382b9db4aecec268c918f43e9a0729a0433e262da
 
-# Build the 5.4 ath10k-ct driver version.  Other option is "-4.19".
+# Build the 5.8 ath10k-ct driver version.
 # Probably this should match as closely as
 # possible to whatever mac80211 backports version is being used.
-CT_KVER="-5.4"
+CT_KVER="-5.8"
 
 PKG_MAINTAINER:=Ben Greear <greearb@candelatech.com>
 PKG_BUILD_PARALLEL:=1
diff --git a/package/kernel/ath10k-ct/patches/164-ath10k-commit-rates-from-mac80211.patch b/package/kernel/ath10k-ct/patches/164-ath10k-commit-rates-from-mac80211.patch
index b913bbdc82..a300ff366a 100644
--- a/package/kernel/ath10k-ct/patches/164-ath10k-commit-rates-from-mac80211.patch
+++ b/package/kernel/ath10k-ct/patches/164-ath10k-commit-rates-from-mac80211.patch
@@ -9,9 +9,17 @@ mcast_rate set for a wifi-iface.
 
 Signed-off-by: Sven Eckelmann <sven@narfation.org>
 
---- a/ath10k-5.4/mac.c
-+++ b/ath10k-5.4/mac.c
-@@ -6796,6 +6796,7 @@ static void ath10k_bss_info_changed(stru
+--- a/ath10k-5.8/mac.c
++++ b/ath10k-5.8/mac.c
+@@ -6652,6 +6652,7 @@ static void ath10k_recalculate_mgmt_rate
+ 		return;
+ 	}
+ 
++	arvif->mgt_rate[def->chan->band] = hw_rate_code;
+ 	vdev_param = ar->wmi.vdev_param->mgmt_rate;
+ 	ret = ath10k_wmi_vdev_set_param(ar, arvif->vdev_id, vdev_param,
+ 					hw_rate_code);
+@@ -6878,6 +6879,7 @@ static void ath10k_bss_info_changed(stru
  			   "mac vdev %d mcast_rate %x\n",
  			   arvif->vdev_id, rate);
  
@@ -19,7 +27,7 @@ Signed-off-by: Sven Eckelmann <sven@narfation.org>
  		vdev_param = ar->wmi.vdev_param->mcast_data_rate;
  		ret = ath10k_wmi_vdev_set_param(ar, arvif->vdev_id,
  						vdev_param, rate);
-@@ -6804,6 +6805,7 @@ static void ath10k_bss_info_changed(stru
+@@ -6886,6 +6888,7 @@ static void ath10k_bss_info_changed(stru
  				    "failed to set mcast rate on vdev %i: %d\n",
  				    arvif->vdev_id,  ret);
  
@@ -27,11 +35,3 @@ Signed-off-by: Sven Eckelmann <sven@narfation.org>
  		vdev_param = ar->wmi.vdev_param->bcast_data_rate;
  		ret = ath10k_wmi_vdev_set_param(ar, arvif->vdev_id,
  						vdev_param, rate);
-@@ -6830,6 +6832,7 @@ static void ath10k_bss_info_changed(stru
- 			return;
- 		}
- 
-+		arvif->mgt_rate[def.chan->band] = hw_rate_code;
- 		vdev_param = ar->wmi.vdev_param->mgmt_rate;
- 		ret = ath10k_wmi_vdev_set_param(ar, arvif->vdev_id, vdev_param,
- 						hw_rate_code);
diff --git a/package/kernel/ath10k-ct/patches/201-ath10k-add-LED-and-GPIO-controlling-support-for-various-chipsets.patch b/package/kernel/ath10k-ct/patches/201-ath10k-add-LED-and-GPIO-controlling-support-for-various-chipsets.patch
index 5291732f25..5ac6bdc34c 100644
--- a/package/kernel/ath10k-ct/patches/201-ath10k-add-LED-and-GPIO-controlling-support-for-various-chipsets.patch
+++ b/package/kernel/ath10k-ct/patches/201-ath10k-add-LED-and-GPIO-controlling-support-for-various-chipsets.patch
@@ -66,25 +66,25 @@ v13:
 
 * cleanup includes
 
- ath10k-5.4/Kconfig   |  10 +++
- ath10k-5.4/Makefile  |   1 +
- ath10k-5.4/core.c    |  22 +++++++
- ath10k-5.4/core.h    |   9 ++-
- ath10k-5.4/hw.h      |   1 +
- ath10k-5.4/leds.c    | 103 ++++++++++++++++++++++++++++++
- ath10k-5.4/leds.h    |  45 +++++++++++++
- ath10k-5.4/mac.c     |   1 +
- ath10k-5.4/wmi-ops.h |  32 ++++++++++
- ath10k-5.4/wmi-tlv.c |   2 +
- ath10k-5.4/wmi.c     |  54 ++++++++++++++++
- ath10k-5.4/wmi.h     |  35 ++++++++++
+ ath10k-5.8/Kconfig   |  10 +++
+ ath10k-5.8/Makefile  |   1 +
+ ath10k-5.8/core.c    |  22 +++++++
+ ath10k-5.8/core.h    |   9 ++-
+ ath10k-5.8/hw.h      |   1 +
+ ath10k-5.8/leds.c    | 103 ++++++++++++++++++++++++++++++
+ ath10k-5.8/leds.h    |  45 +++++++++++++
+ ath10k-5.8/mac.c     |   1 +
+ ath10k-5.8/wmi-ops.h |  32 ++++++++++
+ ath10k-5.8/wmi-tlv.c |   2 +
+ ath10k-5.8/wmi.c     |  54 ++++++++++++++++
+ ath10k-5.8/wmi.h     |  35 ++++++++++
  12 files changed, 314 insertions(+), 1 deletion(-)
- create mode 100644 ath10k-5.4/leds.c
- create mode 100644 ath10k-5.4/leds.h
+ create mode 100644 ath10k-5.8/leds.c
+ create mode 100644 ath10k-5.8/leds.h
 
---- a/ath10k-5.4/Kconfig
-+++ b/ath10k-5.4/Kconfig
-@@ -66,6 +66,16 @@ config ATH10K_DEBUGFS
+--- a/ath10k-5.8/Kconfig
++++ b/ath10k-5.8/Kconfig
+@@ -65,6 +65,16 @@ config ATH10K_DEBUGFS
  
  	  If unsure, say Y to make it easier to debug problems.
  
@@ -101,19 +101,19 @@ v13:
  config ATH10K_SPECTRAL
  	bool "Atheros ath10k spectral scan support"
  	depends on ATH10K_DEBUGFS
---- a/ath10k-5.4/Makefile
-+++ b/ath10k-5.4/Makefile
-@@ -19,6 +19,7 @@ ath10k_core-$(CONFIG_ATH10K_SPECTRAL) +=
+--- a/ath10k-5.8/Makefile
++++ b/ath10k-5.8/Makefile
+@@ -20,6 +20,7 @@ ath10k_core-$(CONFIG_ATH10K_SPECTRAL) +=
  ath10k_core-$(CONFIG_NL80211_TESTMODE) += testmode.o
  ath10k_core-$(CONFIG_ATH10K_TRACING) += trace.o
  ath10k_core-$(CONFIG_THERMAL) += thermal.o
 +ath10k_core-$(CONFIG_ATH10K_LEDS) += leds.o
  ath10k_core-$(CONFIG_MAC80211_DEBUGFS) += debugfs_sta.o
  ath10k_core-$(CONFIG_PM) += wow.o
- ath10k_core-$(CONFIG_DEV_COREDUMP) += coredump.o
---- a/ath10k-5.4/core.c
-+++ b/ath10k-5.4/core.c
-@@ -25,6 +25,7 @@
+ ath10k_core-$(CONFIG_ATH10K_CE) += ce.o
+--- a/ath10k-5.8/core.c
++++ b/ath10k-5.8/core.c
+@@ -26,6 +26,7 @@
  #include "testmode.h"
  #include "wmi-ops.h"
  #include "coredump.h"
@@ -121,7 +121,7 @@ v13:
  
  /* Disable ath10k-ct DBGLOG output by default */
  unsigned int ath10k_debug_mask = ATH10K_DBG_NO_DBGLOG;
-@@ -67,6 +68,7 @@ static const struct ath10k_hw_params ath
+@@ -68,6 +69,7 @@ static const struct ath10k_hw_params ath
  		.dev_id = QCA988X_2_0_DEVICE_ID,
  		.bus = ATH10K_BUS_PCI,
  		.name = "qca988x hw2.0",
@@ -129,7 +129,7 @@ v13:
  		.patch_load_addr = QCA988X_HW_2_0_PATCH_LOAD_ADDR,
  		.uart_pin = 7,
  		.cc_wraparound_type = ATH10K_HW_CC_WRAP_SHIFTED_ALL,
-@@ -137,6 +139,7 @@ static const struct ath10k_hw_params ath
+@@ -138,6 +140,7 @@ static const struct ath10k_hw_params ath
  		.dev_id = QCA9887_1_0_DEVICE_ID,
  		.bus = ATH10K_BUS_PCI,
  		.name = "qca9887 hw1.0",
@@ -137,7 +137,7 @@ v13:
  		.patch_load_addr = QCA9887_HW_1_0_PATCH_LOAD_ADDR,
  		.uart_pin = 7,
  		.cc_wraparound_type = ATH10K_HW_CC_WRAP_SHIFTED_ALL,
-@@ -344,6 +347,7 @@ static const struct ath10k_hw_params ath
+@@ -347,6 +350,7 @@ static const struct ath10k_hw_params ath
  		.dev_id = QCA99X0_2_0_DEVICE_ID,
  		.bus = ATH10K_BUS_PCI,
  		.name = "qca99x0 hw2.0",
@@ -145,7 +145,7 @@ v13:
  		.patch_load_addr = QCA99X0_HW_2_0_PATCH_LOAD_ADDR,
  		.uart_pin = 7,
  		.otp_exe_param = 0x00000700,
-@@ -385,6 +389,7 @@ static const struct ath10k_hw_params ath
+@@ -388,6 +392,7 @@ static const struct ath10k_hw_params ath
  		.dev_id = QCA9984_1_0_DEVICE_ID,
  		.bus = ATH10K_BUS_PCI,
  		.name = "qca9984/qca9994 hw1.0",
@@ -153,7 +153,7 @@ v13:
  		.patch_load_addr = QCA9984_HW_1_0_PATCH_LOAD_ADDR,
  		.uart_pin = 7,
  		.cc_wraparound_type = ATH10K_HW_CC_WRAP_SHIFTED_EACH,
-@@ -433,6 +438,7 @@ static const struct ath10k_hw_params ath
+@@ -436,6 +441,7 @@ static const struct ath10k_hw_params ath
  		.dev_id = QCA9888_2_0_DEVICE_ID,
  		.bus = ATH10K_BUS_PCI,
  		.name = "qca9888 hw2.0",
@@ -161,7 +161,7 @@ v13:
  		.patch_load_addr = QCA9888_HW_2_0_PATCH_LOAD_ADDR,
  		.uart_pin = 7,
  		.cc_wraparound_type = ATH10K_HW_CC_WRAP_SHIFTED_EACH,
-@@ -3573,6 +3579,10 @@ int ath10k_core_start(struct ath10k *ar,
+@@ -3669,6 +3675,10 @@ int ath10k_core_start(struct ath10k *ar,
  			ath10k_wmi_check_apply_board_power_ctl_table(ar);
  	}
  
@@ -172,7 +172,7 @@ v13:
  	return 0;
  
  err_hif_stop:
-@@ -3829,9 +3839,18 @@ static void ath10k_core_register_work(st
+@@ -3927,9 +3937,18 @@ static void ath10k_core_register_work(st
  		goto err_spectral_destroy;
  	}
  
@@ -191,7 +191,7 @@ v13:
  err_spectral_destroy:
  	ath10k_spectral_destroy(ar);
  err_debug_destroy:
-@@ -3891,6 +3910,8 @@ void ath10k_core_unregister(struct ath10
+@@ -3989,6 +4008,8 @@ void ath10k_core_unregister(struct ath10
  	if (!test_bit(ATH10K_FLAG_CORE_REGISTERED, &ar->dev_flags))
  		return;
  
@@ -200,8 +200,8 @@ v13:
  	ath10k_thermal_unregister(ar);
  	/* Stop spectral before unregistering from mac80211 to remove the
  	 * relayfs debugfs file cleanly. Otherwise the parent debugfs tree
---- a/ath10k-5.4/core.h
-+++ b/ath10k-5.4/core.h
+--- a/ath10k-5.8/core.h
++++ b/ath10k-5.8/core.h
 @@ -14,6 +14,7 @@
  #include <linux/pci.h>
  #include <linux/uuid.h>
@@ -210,7 +210,7 @@ v13:
  
  #include "htt.h"
  #include "htc.h"
-@@ -1470,6 +1471,13 @@ struct ath10k {
+@@ -1517,6 +1518,13 @@ struct ath10k {
  	} testmode;
  
  	struct {
@@ -222,11 +222,11 @@ v13:
 +
 +	struct {
  		/* protected by data_lock */
+ 		u32 rx_crc_err_drop;
  		u32 fw_crash_counter;
- 		u32 fw_warm_reset_counter;
---- a/ath10k-5.4/hw.h
-+++ b/ath10k-5.4/hw.h
-@@ -518,6 +518,7 @@ struct ath10k_hw_params {
+--- a/ath10k-5.8/hw.h
++++ b/ath10k-5.8/hw.h
+@@ -521,6 +521,7 @@ struct ath10k_hw_params {
  	const char *name;
  	u32 patch_load_addr;
  	int uart_pin;
@@ -235,7 +235,7 @@ v13:
  
  	/* Type of hw cycle counter wraparound logic, for more info
 --- /dev/null
-+++ b/ath10k-5.4/leds.c
++++ b/ath10k-5.8/leds.c
 @@ -0,0 +1,103 @@
 +/*
 + * Copyright (c) 2005-2011 Atheros Communications Inc.
@@ -341,7 +341,7 @@ v13:
 +}
 +
 --- /dev/null
-+++ b/ath10k-5.4/leds.h
++++ b/ath10k-5.8/leds.h
 @@ -0,0 +1,41 @@
 +/*
 + * Copyright (c) 2018, The Linux Foundation. All rights reserved.
@@ -384,9 +384,9 @@ v13:
 +
 +#endif
 +#endif /* _LEDS_H_ */
---- a/ath10k-5.4/mac.c
-+++ b/ath10k-5.4/mac.c
-@@ -24,6 +24,7 @@
+--- a/ath10k-5.8/mac.c
++++ b/ath10k-5.8/mac.c
+@@ -25,6 +25,7 @@
  #include "wmi-tlv.h"
  #include "wmi-ops.h"
  #include "wow.h"
@@ -394,9 +394,9 @@ v13:
  
  /*********/
  /* Rates */
---- a/ath10k-5.4/wmi-ops.h
-+++ b/ath10k-5.4/wmi-ops.h
-@@ -219,7 +219,10 @@ struct wmi_ops {
+--- a/ath10k-5.8/wmi-ops.h
++++ b/ath10k-5.8/wmi-ops.h
+@@ -226,7 +226,10 @@ struct wmi_ops {
  	struct sk_buff *(*gen_bb_timing)
  			(struct ath10k *ar,
  			 const struct wmi_bb_timing_cfg_arg *arg);
@@ -407,7 +407,7 @@ v13:
  };
  
  int ath10k_wmi_cmd_send(struct ath10k *ar, struct sk_buff *skb, u32 cmd_id);
-@@ -1115,6 +1118,35 @@ ath10k_wmi_force_fw_hang(struct ath10k *
+@@ -1145,6 +1148,35 @@ ath10k_wmi_force_fw_hang(struct ath10k *
  	return ath10k_wmi_cmd_send(ar, skb, ar->wmi.cmd->force_fw_hang_cmdid);
  }
  
@@ -443,9 +443,9 @@ v13:
  static inline int
  ath10k_wmi_dbglog_cfg(struct ath10k *ar, u64 module_enable, u32 log_level)
  {
---- a/ath10k-5.4/wmi-tlv.c
-+++ b/ath10k-5.4/wmi-tlv.c
-@@ -4382,6 +4382,8 @@ static const struct wmi_ops wmi_tlv_ops
+--- a/ath10k-5.8/wmi-tlv.c
++++ b/ath10k-5.8/wmi-tlv.c
+@@ -4583,6 +4583,8 @@ static const struct wmi_ops wmi_tlv_ops
  	.gen_echo = ath10k_wmi_tlv_op_gen_echo,
  	.gen_vdev_spectral_conf = ath10k_wmi_tlv_op_gen_vdev_spectral_conf,
  	.gen_vdev_spectral_enable = ath10k_wmi_tlv_op_gen_vdev_spectral_enable,
@@ -454,9 +454,9 @@ v13:
  };
  
  static const struct wmi_peer_flags_map wmi_tlv_peer_flags_map = {
---- a/ath10k-5.4/wmi.c
-+++ b/ath10k-5.4/wmi.c
-@@ -8305,6 +8305,49 @@ ath10k_wmi_op_gen_peer_set_param(struct
+--- a/ath10k-5.8/wmi.c
++++ b/ath10k-5.8/wmi.c
+@@ -8404,6 +8404,49 @@ ath10k_wmi_op_gen_peer_set_param(struct
  	return skb;
  }
  
@@ -506,7 +506,7 @@ v13:
  static struct sk_buff *
  ath10k_wmi_op_gen_set_psmode(struct ath10k *ar, u32 vdev_id,
  			     enum wmi_sta_ps_mode psmode)
-@@ -10104,6 +10147,9 @@ static const struct wmi_ops wmi_ops = {
+@@ -10203,6 +10246,9 @@ static const struct wmi_ops wmi_ops = {
  	.fw_stats_fill = ath10k_wmi_main_op_fw_stats_fill,
  	.get_vdev_subtype = ath10k_wmi_op_get_vdev_subtype,
  	.gen_echo = ath10k_wmi_op_gen_echo,
@@ -516,7 +516,7 @@ v13:
  	/* .gen_bcn_tmpl not implemented */
  	/* .gen_prb_tmpl not implemented */
  	/* .gen_p2p_go_bcn_ie not implemented */
-@@ -10174,6 +10220,8 @@ static const struct wmi_ops wmi_10_1_ops
+@@ -10273,6 +10319,8 @@ static const struct wmi_ops wmi_10_1_ops
  	.fw_stats_fill = ath10k_wmi_10x_op_fw_stats_fill,
  	.get_vdev_subtype = ath10k_wmi_op_get_vdev_subtype,
  	.gen_echo = ath10k_wmi_op_gen_echo,
@@ -525,7 +525,7 @@ v13:
  	/* .gen_bcn_tmpl not implemented */
  	/* .gen_prb_tmpl not implemented */
  	/* .gen_p2p_go_bcn_ie not implemented */
-@@ -10253,6 +10301,8 @@ static const struct wmi_ops wmi_10_2_ops
+@@ -10352,6 +10400,8 @@ static const struct wmi_ops wmi_10_2_ops
  	.gen_delba_send = ath10k_wmi_op_gen_delba_send,
  	.fw_stats_fill = ath10k_wmi_10x_op_fw_stats_fill,
  	.get_vdev_subtype = ath10k_wmi_op_get_vdev_subtype,
@@ -534,7 +534,7 @@ v13:
  	/* .gen_pdev_enable_adaptive_cca not implemented */
  };
  
-@@ -10324,6 +10374,8 @@ static const struct wmi_ops wmi_10_2_4_o
+@@ -10423,6 +10473,8 @@ static const struct wmi_ops wmi_10_2_4_o
  		ath10k_wmi_op_gen_pdev_enable_adaptive_cca,
  	.get_vdev_subtype = ath10k_wmi_10_2_4_op_get_vdev_subtype,
  	.gen_bb_timing = ath10k_wmi_10_2_4_op_gen_bb_timing,
@@ -543,7 +543,7 @@ v13:
  	/* .gen_bcn_tmpl not implemented */
  	/* .gen_prb_tmpl not implemented */
  	/* .gen_p2p_go_bcn_ie not implemented */
-@@ -10405,6 +10457,8 @@ static const struct wmi_ops wmi_10_4_ops
+@@ -10504,6 +10556,8 @@ static const struct wmi_ops wmi_10_4_ops
  	.gen_pdev_bss_chan_info_req = ath10k_wmi_10_2_op_gen_pdev_bss_chan_info,
  	.gen_echo = ath10k_wmi_op_gen_echo,
  	.gen_pdev_get_tpc_config = ath10k_wmi_10_2_4_op_gen_pdev_get_tpc_config,
@@ -552,9 +552,9 @@ v13:
  };
  
  int ath10k_wmi_attach(struct ath10k *ar)
---- a/ath10k-5.4/wmi.h
-+++ b/ath10k-5.4/wmi.h
-@@ -3110,6 +3110,41 @@ enum wmi_10_4_feature_mask {
+--- a/ath10k-5.8/wmi.h
++++ b/ath10k-5.8/wmi.h
+@@ -3121,6 +3121,41 @@ enum wmi_10_4_feature_mask {
  
  };
  
diff --git a/package/kernel/ath10k-ct/patches/202-ath10k-use-tpt-trigger-by-default.patch b/package/kernel/ath10k-ct/patches/202-ath10k-use-tpt-trigger-by-default.patch
index 838158c7e0..ec03fc0632 100644
--- a/package/kernel/ath10k-ct/patches/202-ath10k-use-tpt-trigger-by-default.patch
+++ b/package/kernel/ath10k-ct/patches/202-ath10k-use-tpt-trigger-by-default.patch
@@ -9,14 +9,14 @@ traffic.
 
 Signed-off-by: Mathias Kresin <dev@kresin.me>
 ---
- ath10k-5.4/core.h | 4 ++++
- ath10k-5.4/leds.c | 4 +---
- ath10k-5.4/mac.c  | 2 +-
+ ath10k-5.8/core.h | 4 ++++
+ ath10k-5.8/leds.c | 4 +---
+ ath10k-5.8/mac.c  | 2 +-
  3 files changed, 6 insertions(+), 4 deletions(-)
 
---- a/ath10k-5.4/core.h
-+++ b/ath10k-5.4/core.h
-@@ -1574,6 +1574,10 @@ struct ath10k {
+--- a/ath10k-5.8/core.h
++++ b/ath10k-5.8/core.h
+@@ -1625,6 +1625,10 @@ struct ath10k {
  	u8 csi_data[4096];
  	u16 csi_data_len;
  
@@ -25,10 +25,10 @@ Signed-off-by: Mathias Kresin <dev@kresin.me>
 +#endif
 +
  	/* must be last */
- 	u8 drv_priv[0] __aligned(sizeof(void *));
+ 	u8 drv_priv[] __aligned(sizeof(void *));
  };
---- a/ath10k-5.4/leds.c
-+++ b/ath10k-5.4/leds.c
+--- a/ath10k-5.8/leds.c
++++ b/ath10k-5.8/leds.c
 @@ -81,9 +81,7 @@ int ath10k_leds_register(struct ath10k *
  
  	ar->leds.cdev.name = ar->leds.label;
@@ -40,9 +40,9 @@ Signed-off-by: Mathias Kresin <dev@kresin.me>
  
  	ret = led_classdev_register(wiphy_dev(ar->hw->wiphy), &ar->leds.cdev);
  	if (ret)
---- a/ath10k-5.4/mac.c
-+++ b/ath10k-5.4/mac.c
-@@ -10386,7 +10386,7 @@ int ath10k_mac_register(struct ath10k *a
+--- a/ath10k-5.8/mac.c
++++ b/ath10k-5.8/mac.c
+@@ -10679,7 +10679,7 @@ int ath10k_mac_register(struct ath10k *a
  	ar->hw->weight_multiplier = ATH10K_AIRTIME_WEIGHT_MULTIPLIER;
  
  #ifdef CPTCFG_MAC80211_LEDS
diff --git a/package/kernel/ath10k-ct/patches/205-ath10k-Add-NL80211_EXT_FEATURE_AQL-flag.patch b/package/kernel/ath10k-ct/patches/205-ath10k-Add-NL80211_EXT_FEATURE_AQL-flag.patch
deleted file mode 100644
index 09dd13e9a4..0000000000
--- a/package/kernel/ath10k-ct/patches/205-ath10k-Add-NL80211_EXT_FEATURE_AQL-flag.patch
+++ /dev/null
@@ -1,10 +0,0 @@
---- a/ath10k-5.4/mac.c
-+++ b/ath10k-5.4/mac.c
-@@ -10185,6 +10185,7 @@ int ath10k_mac_register(struct ath10k *a
- 	wiphy_ext_feature_set(ar->hw->wiphy, NL80211_EXT_FEATURE_VHT_IBSS);
- 	wiphy_ext_feature_set(ar->hw->wiphy,
- 			      NL80211_EXT_FEATURE_SET_SCAN_DWELL);
-+	wiphy_ext_feature_set(ar->hw->wiphy, NL80211_EXT_FEATURE_AQL);
- 
- 	if (test_bit(WMI_SERVICE_TX_DATA_ACK_RSSI, ar->wmi.svc_map) ||
- 	    test_bit(WMI_SERVICE_HTT_MGMT_TX_COMP_VALID_FLAGS, ar->wmi.svc_map))
diff --git a/package/kernel/ath10k-ct/patches/960-0010-ath10k-limit-htt-rx-ring-size.patch b/package/kernel/ath10k-ct/patches/960-0010-ath10k-limit-htt-rx-ring-size.patch
index c527430898..5b52a434f9 100644
--- a/package/kernel/ath10k-ct/patches/960-0010-ath10k-limit-htt-rx-ring-size.patch
+++ b/package/kernel/ath10k-ct/patches/960-0010-ath10k-limit-htt-rx-ring-size.patch
@@ -1,6 +1,6 @@
---- a/ath10k-5.4/htt.h
-+++ b/ath10k-5.4/htt.h
-@@ -225,7 +225,11 @@ enum htt_rx_ring_flags {
+--- a/ath10k-5.8/htt.h
++++ b/ath10k-5.8/htt.h
+@@ -237,7 +237,11 @@ enum htt_rx_ring_flags {
  };
  
  #define HTT_RX_RING_SIZE_MIN 128
diff --git a/package/kernel/ath10k-ct/patches/960-0011-ath10k-limit-pci-buffer-size.patch b/package/kernel/ath10k-ct/patches/960-0011-ath10k-limit-pci-buffer-size.patch
index f559a78f29..98653d6b72 100644
--- a/package/kernel/ath10k-ct/patches/960-0011-ath10k-limit-pci-buffer-size.patch
+++ b/package/kernel/ath10k-ct/patches/960-0011-ath10k-limit-pci-buffer-size.patch
@@ -1,6 +1,6 @@
---- a/ath10k-5.4/pci.c
-+++ b/ath10k-5.4/pci.c
-@@ -131,7 +131,11 @@ static struct ce_attr host_ce_config_wla
+--- a/ath10k-5.8/pci.c
++++ b/ath10k-5.8/pci.c
+@@ -131,7 +131,11 @@ static const struct ce_attr pci_host_ce_
  		.flags = CE_ATTR_FLAGS,
  		.src_nentries = 0,
  		.src_sz_max = 2048,
@@ -12,7 +12,7 @@
  		.recv_cb = ath10k_pci_htt_htc_rx_cb,
  	},
  
-@@ -140,7 +144,11 @@ static struct ce_attr host_ce_config_wla
+@@ -140,7 +144,11 @@ static const struct ce_attr pci_host_ce_
  		.flags = CE_ATTR_FLAGS,
  		.src_nentries = 0,
  		.src_sz_max = 2048,
@@ -24,7 +24,7 @@
  		.recv_cb = ath10k_pci_htc_rx_cb,
  	},
  
-@@ -167,7 +175,11 @@ static struct ce_attr host_ce_config_wla
+@@ -167,7 +175,11 @@ static const struct ce_attr pci_host_ce_
  		.flags = CE_ATTR_FLAGS,
  		.src_nentries = 0,
  		.src_sz_max = 512,
@@ -36,7 +36,7 @@
  		.recv_cb = ath10k_pci_htt_rx_cb,
  	},
  
-@@ -192,7 +204,11 @@ static struct ce_attr host_ce_config_wla
+@@ -192,7 +204,11 @@ static const struct ce_attr pci_host_ce_
  		.flags = CE_ATTR_FLAGS,
  		.src_nentries = 0,
  		.src_sz_max = 2048,